package org.apache.bcel.generic;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.generic.ClassGenException;
import org.apache.bcel.generic.ConstantPoolGen;
import org.apache.bcel.generic.ExceptionThrower;
import org.apache.bcel.generic.Instruction;
import org.apache.bcel.generic.StackConsumer;
import org.apache.bcel.generic.Type;
import org.apache.bcel.generic.TypedInstruction;

public abstract class ReturnInstruction extends Instruction implements ExceptionThrower, TypedInstruction, StackConsumer {
  ReturnInstruction() {}
  
  protected ReturnInstruction(short opcode) {
    super(opcode, (short)1);
  }
  
  public Class<?>[] getExceptions() {
    return new Class[] { ExceptionConst.ILLEGAL_MONITOR_STATE };
  }
  
  public Type getType() {
    short opcode = getOpcode();
    switch (opcode) {
      case 172:
        return Type.INT;
      case 173:
        return Type.LONG;
      case 174:
        return Type.FLOAT;
      case 175:
        return Type.DOUBLE;
      case 176:
        return Type.OBJECT;
      case 177:
        return Type.VOID;
    } 
    throw new ClassGenException("Unknown type " + opcode);
  }
  
  public Type getType(ConstantPoolGen cp) {
    return getType();
  }
}
